$TABLET-MIN-WIDTH: 576px;
$TABLET-LARGE-MIN-WIDTH: 768px;
$DESKTOP-MIN-WIDTH: 992px;
$DESKTOP-LARGE-MIN-WIDTH: 1200px;

@mixin tablet {
    @media only screen and (min-width: $TABLET-MIN-WIDTH) {
        @content;
    }
}

@mixin tablet-large {
    @media only screen and (min-width: $TABLET-LARGE-MIN-WIDTH) {
        @content;
    }
}

@mixin desktop {
    @media only screen and (min-width: $DESKTOP-MIN-WIDTH) {
        @content;
    }
}

@mixin desktop-large {
    @media only screen and (min-width: $DESKTOP-LARGE-MIN-WIDTH) {
        @content;
    }
}

@mixin define-section($class) {
    .site > .main-content > section.#{$class} {
        overflow: hidden;
        @content;
    }
}

.generic-table-control-panel {
    $border-radius: 0.3rem;

    user-select: none;
    display: block;
    margin: -0.5rem;

    > * {
        margin: 0.5rem;
        float: left;
        display: block;
    }

    button {
        display: block;
        background-color: #334966;
        color: rgb(228, 239, 252);
        padding: 0 1rem;
        border: none;
        font-size: 1rem;
        font-weight: 400;
        cursor: pointer;
        border-radius: $border-radius;
        white-space: nowrap;
        height: 3rem;
        line-height: 3rem;

        > i, span {
            display: inline-block;
        }

        > span {
            margin-left: 1rem;
        }

        &:focus {
            outline: none;
        }

        &:disabled {
            background-color: rgb(155, 155, 160);
            cursor: default;
        }

        &:hover:not(:disabled), &:focus:not(:disabled) {
            background-color: #3b567a;
            color: white;
        }
    }
}

.generic-table {
    $border-radius: 0.3rem;
    $separator-border: 1px solid #C1C3D1;

    background: white;
    border-radius: $border-radius;
    border-collapse: collapse;
    box-shadow: 0 5px 10px rgba(0, 0, 0, 0.1);
    animation: float 5s infinite;
    width: 100%;

    th {
        color: #D5DDE5;
        background: #233245;
        border-bottom: 0.2rem solid #9ea7af;
        border-right: 1px solid #343a45;
        font-size: 1rem;
        font-weight: 400;
        padding: 1rem;
        text-align: left;
        vertical-align: middle;
        white-space: nowrap;
        text-overflow: ellipsis;

        &:first-child {
            border-top-left-radius: $border-radius;
        }

        &:last-child {
            border-top-right-radius: $border-radius;
            border-right: none;
        }

        &.text-left {
            text-align: left;
        }

        &.text-center {
            text-align: center;
        }

        &.text-right {
            text-align: right;
        }
    }

    tr {
        border-top: $separator-border;
        border-bottom: $separator-border;
        color: #666B85;
        font-weight: normal;

        &:first-child {
            border-top: none;
        }

        &:last-child {
            border-bottom: none;
        }

        &:last-child td:first-child {
            border-bottom-left-radius: $border-radius;
        }

        &:last-child td:last-child {
            border-bottom-right-radius: $border-radius;
        }

        > td {
            background: #FFFFFF;
            padding: 0.4rem 1rem;
            text-align: left;
            vertical-align: middle;
            font-size: 1rem;
            white-space: nowrap;
            text-overflow: ellipsis;

            &:not(:last-child) {
                border-right: $separator-border;
            }
        }
    }

    &.interactive tr:hover > td {
        background: #35475e;
        color: #FFFFFF;
        border-top: 1px solid #22262e;
    }
}

.generic-pop-over {
    display: block;
    width: 100%;
    //border: 0.13rem solid #3b567a;
    border-radius: 0.3rem;
    background-color: #e0e5eb;
    padding: 0.5rem 1rem;
    font-style: italic;
}

.generic-labeled-text-input {
    > .label {
        display: block;
        width: 100%;
        font-weight: bold;
        color: #677180;
    }

    > input[type='text'] {
        display: block;
        width: 100%;
        padding: 0.5rem;
        border: none;
        border-bottom: 0.13rem solid #a8aeb6;
        outline: none;
        color: #565d69;
        transition: border-bottom 0.3s ease, color 0.3s ease;
        background: transparent;

        &::placeholder {
            color: #a8aeb6;
            font-style: italic;
            transition: color 0.3s ease;
        }

        &:focus {
            border-bottom: 0.13rem solid #233245;
            color: #343a45;

            &::placeholder {
                color: #8a95a1;
            }
        }
    }
}

.generic-input-button {
    padding: 0 1rem;
    height: 2.5rem;
    line-height: 2.5rem;
    border: none;
    text-align: center;
    background-color: #36567e;
    color: white;
    cursor: pointer;
    outline: none;
    border-radius: 0.3rem;
    transition: background-color 0.2s ease, color 0.2s ease;

    &:disabled {
        cursor: default;
        background-color: #a9afb8;
    }

    &:focus:not(:disabled), &:hover:not(:disabled) {
        background-color: #4970a1;
    }
}

.generic-labeled-select {
    > .label {
        display: block;
        width: 100%;
        font-weight: bold;
        color: #677180;
    }

    > .select-container {
        border-bottom: 0.13rem solid #a8aeb6;
        transition: border-bottom 0.3s ease, color 0.3s ease;
        position: relative;

        > select {
            border: none;
            outline: none;
            color: #565d69;
            background: transparent;
            width: 100%;
            appearance: none; // hide default arrow
            padding: 0.5rem;

            &:-moz-focusring {
                color: transparent;
                text-shadow: 0 0 0 #000;
            }
        }

        &::after {
            // align-self: center;
            // justify-self: right;
            transition: color 0.3s ease;
            pointer-events: none;
            position: absolute;
            top: 0;
            right: 0;
            padding: 0.5rem;
            font-family: "Font Awesome 5 Free";
            font-weight: 900;
            content: "\f078"; /* down arrow */
            color: #a8aeb6;
        }

        &.focus {//TODO: must use javascript
            border-bottom: 0.13rem solid #233245;
            color: #343a45;

            &::after {
                color: #343a45;
            }
        }
    }
}

.generic-labeled-textarea {
    > .label {
        display: block;
        width: 100%;
        font-weight: bold;
        color: #677180;
    }

    > textarea {
        display: block;
        width: 100%;
        padding: 0.5rem;
        border: none;
        // border-right: 0.13rem solid #a8aeb6;
        border-bottom: 0.13rem solid #a8aeb6;
        outline: none;
        color: #565d69;
        transition: border 0.3s ease, color 0.3s ease;
        background: rgba(#000, 0.02);

        &:focus {
            // border-right: 0.13rem solid #233245;
            border-bottom: 0.13rem solid #233245;
            color: #343a45;
        }
    }
}

.generic-labeled-select-text-input {
    display: grid;
    grid-template-areas:
        "label"
        "select"
        "text";
    grid-template-columns: 1fr;
    grid-template-rows: auto auto auto;
    place-items: stretch;
    place-content: stretch;
    column-gap: 1rem;
    row-gap: 0.5rem;

    @include tablet {
        grid-template-areas:
            "label label"
            "select text";
        grid-template-columns: 1fr 1fr;
        grid-template-rows: auto auto;
        row-gap: 0;
    }

    > .label {
        grid-area: label;
        font-weight: bold;
        color: #677180;
    }

    > .select-container {
        border-bottom: 0.13rem solid #a8aeb6;
        transition: border-bottom 0.3s ease, color 0.3s ease;
        position: relative;

        > select {
            border: none;
            outline: none;
            color: #565d69;
            background: transparent;
            width: 100%;
            appearance: none; // hide default arrow
            padding: 0.5rem;

            &:-moz-focusring {
                color: transparent;
                text-shadow: 0 0 0 #000;
            }
        }

        &::after {
            // align-self: center;
            // justify-self: right;
            transition: color 0.3s ease;
            pointer-events: none;
            position: absolute;
            top: 0;
            right: 0;
            padding: 0.5rem;
            font-family: "Font Awesome 5 Free";
            font-weight: 900;
            content: "\f078"; /* down arrow */
            color: #a8aeb6;
        }

        &.focus {//TODO: must use javascript
            border-bottom: 0.13rem solid #233245;
            color: #343a45;

            &::after {
                color: #343a45;
            }
        }
    }

    > input[type='text'] {
        grid-area: text;
        padding: 0.5rem;
        border: none;
        border-bottom: 0.13rem solid #a8aeb6;
        outline: none;
        color: #565d69;
        transition: border-bottom 0.3s ease, color 0.3s ease;
        background: transparent;

        &::placeholder {
            color: #a8aeb6;
            font-style: italic;
            transition: color 0.3s ease;
        }

        &:focus {
            border-bottom: 0.13rem solid #233245;
            color: #343a45;

            &::placeholder {
                color: #8a95a1;
            }
        }
    }
}